/*
  Crystal Space Scoped Mutex Lock Class
  Copyright (C) 2003 by Matze Braun

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __CSUTIL_SCOPEDLOCK_H__
#define __CSUTIL_SCOPEDLOCK_H__

/**\file
 * Scoped mutex locking
 */

#include "csextern.h"


template<class T>
class csScopedLock
{
public:
  csScopedLock (T& lock)
    : lock (lock)
  { lock.LockWait (); }
  ~csScopedLock ()
  { lock.Release (); }

  T& lock;
};


#endif

